package com.demo;

import java.awt.BasicStroke;
import java.awt.Color;

import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.axis.ValueAxis;
import org.jfree.chart.axis.NumberAxis;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.data.xy.XYDataset;
import org.jfree.ui.RectangleInsets;
import org.jfree.ui.ApplicationFrame;
import org.jfree.ui.RefineryUtilities;
import org.jfree.chart.renderer.xy.XYLineAndShapeRenderer;

public class LineChart2 extends ApplicationFrame
{
	private static final long serialVersionUID = 1L;

    public LineChart2(final String title) 
    {
    	 super(title);

    	 XYDataset   dataset    = Dataset.createDataset2(-1);
         JFreeChart  chart      = createChart(dataset);
         ChartPanel  chartPanel = new ChartPanel(chart);
         
         chartPanel.setPreferredSize(new java.awt.Dimension(560, 480));
         setContentPane(chartPanel);
    }

    private JFreeChart createChart(XYDataset dataset)
    {
        final JFreeChart chart = ChartFactory.createXYLineChart(
            "Линейный график 2",
            null,                        // x axis label
            null,                        // y axis label
            dataset,                     // data
            PlotOrientation.VERTICAL,
            true,                        // include legend
            false,                       // tooltips
            false                        // urls
        );

        chart.setBackgroundPaint(Color.white);

        final XYPlot plot = chart.getXYPlot();
        plot.setBackgroundPaint(new Color(232, 232, 232));

        plot.setDomainGridlinePaint(Color.gray);
        plot.setRangeGridlinePaint (Color.gray);
        
        // Определение отступа меток делений
        plot.setAxisOffset(new RectangleInsets (1.0, 1.0, 1.0, 1.0));

        // Скрытие осевых линий и меток делений
        ValueAxis axis = plot.getDomainAxis();
        axis.setAxisLineVisible (false);    // осевая линия
        
        XYLineAndShapeRenderer renderer = new XYLineAndShapeRenderer();
        // Удаление связующих линий Series 1
        renderer.setSeriesLinesVisible (0, false);
        // Удаление меток Series 2
        renderer.setSeriesShapesVisible(1, false);

        // Настройка графика (цвет, ширина линии) Series 3
        renderer.setSeriesPaint        (2, Color.orange);
        renderer.setSeriesStroke       (2, new BasicStroke(2.5f));
        plot.setRenderer(renderer);
        
        // Настройка NumberAxis
        final NumberAxis rangeAxis = (NumberAxis) plot.getRangeAxis();
        
        rangeAxis.setAxisLineVisible (false);
        rangeAxis.setStandardTickUnits(NumberAxis.createIntegerTickUnits());

        return chart;
    }
    
    public static void main(final String[] args) 
    {
        final LineChart2 demo = new LineChart2("Линейный график 2");
        demo.pack();
        RefineryUtilities.centerFrameOnScreen(demo);
        demo.setVisible(true);
    }
}
